    001/*
    002 * Licensed to the Apache Software Foundation (ASF) under one or more
    003 * contributor license agreements.  See the NOTICE file distributed with
    004 * this work for additional information regarding copyright ownership.
    005 * The ASF licenses this file to You under the Apache License, Version 2.0
    006 * (the "License"); you may not use this file except in compliance with
    007 * the License.  You may obtain a copy of the License at
    008 *
    009 *      https://www.apache.org/licenses/LICENSE-2.0
    010 *
    011 * Unless required by applicable law or agreed to in writing, software
    012 * distributed under the License is distributed on an "AS IS" BASIS,
    013 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    014 * See the License for the specific language governing permissions and
    015 * limitations under the License.
    016 */
    017
    018package org.apache.commons.codec.binary;
    019
    020import java.io.OutputStream;
    021
    022import org.apache.commons.codec.CodecPolicy;
    023
    024/**
    025 * Provides Base64 encoding and decoding in a streaming fashion (unlimited size). When encoding the default lineLength
    026 * is 76 characters and the default lineEnding is CRLF, but these can be overridden by using the appropriate
    027 * constructor.
    028 * <p>
    029 * The default behavior of the Base64OutputStream is to ENCODE, whereas the default behavior of the Base64InputStream
    030 * is to DECODE. But this behavior can be overridden by using a different constructor.
    031 * </p>
    032 * <p>
    033 * This class implements section <cite>6.8. Base64 Content-Transfer-Encoding</cite> from RFC 2045 <cite>Multipurpose
    034 * Internet Mail Extensions (MIME) Part One: Format of Internet Message Bodies</cite> by Freed and Borenstein.
    035 * </p>
    036 * <p>
    037 * Since this class operates directly on byte streams, and not character streams, it is hard-coded to only encode/decode
    038 * character encodings which are compatible with the lower 127 ASCII chart (ISO-8859-1, Windows-1252, UTF-8, etc).
    039 * </p>
    040 * <p>
    041 * <strong>Note:</strong> It is mandatory to close the stream after the last byte has been written to it, otherwise the
    042 * final padding will be omitted and the resulting data will be incomplete/inconsistent.
    043 * </p>
    044 * <p>
    045 * You can set the decoding behavior when the input bytes contain leftover trailing bits that cannot be created by a
    046 * valid encoding. These can be bits that are unused from the final character or entire characters. The default mode is
    047 * lenient decoding.
    048 * </p>
    049 * <ul>
    050 * <li>Lenient: Any trailing bits are composed into 8-bit bytes where possible. The remainder are discarded.
    051 * <li>Strict: The decoding will raise an {@link IllegalArgumentException} if trailing bits are not part of a valid
    052 * encoding. Any unused bits from the final character must be zero. Impossible counts of entire final characters are not
    053 * allowed.
    054 * </ul>
    055 * <p>
    056 * When strict decoding is enabled it is expected that the decoded bytes will be re-encoded to a byte array that matches
    057 * the original, i.e. no changes occur on the final character. This requires that the input bytes use the same padding
    058 * and alphabet as the encoder.
    059 * </p>
    060 * @see <a href="http://www.ietf.org/rfc/rfc2045.txt">RFC 2045</a>
    061 * @since 1.4
    062 */
    063public class Base64OutputStream extends BaseNCodecOutputStream {
    064
    065    /**
    066     * Constructs a Base64OutputStream such that all data written is Base64-encoded to the original provided OutputStream.
    067     *
    068     * @param outputStream
    069     *            OutputStream to wrap.
    070     */
    071    public Base64OutputStream(final OutputStream outputStream) {
    072        this(outputStream, true);
    073    }
    074
    075    /**
    076     * Constructs a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the
    077     * original provided OutputStream.
    078     *
    079     * @param outputStream
    080     *            OutputStream to wrap.
    081     * @param doEncode
    082     *            true if we should encode all data written to us, false if we should decode.
    083     */
    084    public Base64OutputStream(final OutputStream outputStream, final boolean doEncode) {
    085        super(outputStream, new Base64(false), doEncode);
    086    }
    087
    088    /**
    089     * Constructs a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the
    090     * original provided OutputStream.
    091     *
    092     * @param outputStream
    093     *            OutputStream to wrap.
    094     * @param doEncode
    095     *            true if we should encode all data written to us, false if we should decode.
    096     * @param lineLength
    097     *            If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to
    098     *            the nearest multiple of 4). If lineLength &lt;= 0, the encoded data is not divided into lines. If
    099     *            doEncode is false, lineLength is ignored.
    100     * @param lineSeparator
    101     *            If doEncode is true, each line of encoded data will be terminated with this byte sequence (e.g. \r\n).
    102     *            If lineLength &lt;= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.
    103     */
    104    public Base64OutputStream(final OutputStream outputStream, final boolean doEncode, final int lineLength, final byte[] lineSeparator) {
    105        super(outputStream, new Base64(lineLength, lineSeparator), doEncode);
    106    }
    107
    108    /**
    109     * Constructs a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the
    110     * original provided OutputStream.
    111     *
    112     * @param outputStream
    113     *            OutputStream to wrap.
    114     * @param doEncode
    115     *            true if we should encode all data written to us, false if we should decode.
    116     * @param lineLength
    117     *            If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to
    118     *            the nearest multiple of 4). If lineLength &lt;= 0, the encoded data is not divided into lines. If
    119     *            doEncode is false, lineLength is ignored.
    120     * @param lineSeparator
    121     *            If doEncode is true, each line of encoded data will be terminated with this byte sequence (e.g. \r\n).
    122     *            If lineLength &lt;= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.
    123     * @param decodingPolicy The decoding policy.
    124     * @since 1.15
    125     */
    126    public Base64OutputStream(final OutputStream outputStream, final boolean doEncode, final int lineLength, final byte[] lineSeparator,
    127        final CodecPolicy decodingPolicy) {
    128        super(outputStream, new Base64(lineLength, lineSeparator, false, decodingPolicy), doEncode);
    129    }
    130}